<?php

function _pluginMain($prmQuery) {
  $queryData = array();
  parse_str($prmQuery, $queryData);
  if ($queryData['category_url'] !='') {
    if (strcmp($queryData['category_url'],'http://www.cinetube.es/peliculas/'))
      $pageCount = 20;
    else
      $pageCount = 1;
    $items = _pluginCreateMovieItems($queryData['category_url'],$pageCount);
    return $items;
  } elseif ($queryData['movie_url'] !='') {
    $items = _pluginCreateVideoItems($queryData['movie_url']);
    return $items;
  } else {
  $items = _pluginCreateCategoryList();
  return $items;
  }
}

function _pluginCreateCategoryList() {
  $categories = array(
    '** Novedades **' => 'novedades',
    'Acci&oacute;n' => 'accion',
    'Adolescente' => 'adolescente',
    'Animaci&oacute;n e Infantil' => 'animacion-e-infantil',
    'Artes Marciales' => 'artes-marciales',
    'Aventura' => 'aventura',
    'B&eacute;lico' => 'belico',
    'Biogr&aacute;fica' => 'biografica',
    'Ciencia Ficci&oacute;n' => 'ciencia-ficcion',
    'Cine negro' => 'cine-negro',
    'Comedia' => 'comedia',
    'Cortometrajes' => 'cortometrajes',
    'Deporte' => 'deporte',
    'Drama' => 'drama',
    'Fant&aacute;stico' => 'fantastico',
    'Hist&oacute;rico' => 'historico',
    'Intriga' => 'intriga',
    'Musical' => 'musical',
    'Policiaca' => 'policiaca',
    'Romance' => 'romance',
    'Suspense' => 'suspense',
    'Terror' => 'terror',
    'Thriller' => 'thriller',
    'Western' => 'western'
  );

  foreach ($categories as $name => $id) {
    $url = "http://www.cinetube.es/peliculas/";
    if ($id!='novedades') $url = $url . $id . "/";
   
    $data = array(
      'category_url' => $url
    );
    $dataString = http_build_query($data, 'pluginvar_');
    $retMediaItems[] = array (
      'id' => 'umsp://plugins/cinetube?' . $dataString,
      'dc:title' => html_entity_decode($name,0,"UTF-8"),
      'upnp:class' => 'object.container',
    );
  }
  return $retMediaItems;
}

function _pluginCreateMovieItems($url,$pageCount) {

  for ($i = 1; $i <= $pageCount; $i++) {
   
    $html = file_get_contents($url . $i . ".html");
    preg_match_all('/<p class="white">(.*?)<\/p><\/a>/',$html,$title);
   
    if (empty($title[1])) break;
   
    preg_match_all('/<img src="(http:\/\/caratulas.cinetube.es\/pelis\/.*?)" alt/',$html,$poster);
   
    if($pageCount == 1)
      preg_match_all('/<div class="pelicula_img"><a href=\'(.*)\' >/',$html,$link);
    else
      preg_match_all('/<div class="pelicula_img"><a href="(.*)">/',$html,$link);
   
    for ($z = 0; $z < sizeof($title[1]); $z++) {
      $data = array(
        'movie_url' => "http://www.cinetube.es" . $link[1][$z]
      );
      $dataString = http_build_query($data, 'pluginvar_');
      $retMediaItems[] = array (
        'id' => 'umsp://plugins/cinetube?' . $dataString,
        'dc:title' => html_entity_decode($title[1][$z],0,"UTF-8"),
        'upnp:album_art'=> $poster[1][$z+20],
        'upnp:class' => 'object.container',
      );
    }
  }
  return $retMediaItems;
}

function _pluginCreateVideoItems($url) {
  $html = file_get_contents($url);

  preg_match_all('/<div class="tit_opts"><a href="(.*megavideo.*.html?)">/',$html,$megavid);
  preg_match('/<h1 class="bold">(.*?)<\/h1>/',$html,$title);
  preg_match_all('/<p><span>CALIDAD: (.*?)\s*\|/',$html,$quality);
  preg_match_all('/IDIOMA: (.*?)\s*<\/span><\/p>/',$html,$language);
 
  if (file_exists('/conf/config')) {
    $config = file_get_contents('/conf/config');
    if(preg_match('/MEGA_AUTH=\'(.+)\'/', $config, $config_result)) {
      $auth = $config_result[1];
      preg_match_all('/<div class="tit_opts"><a href="(.*megaupload.*.html?)"/',$html,$megaup);
    }
  }
   
  for ($z = 0; $z < sizeof($megavid[1]); $z++) {
    $html = file_get_contents("http://www.cinetube.es" . $megavid[1][$z]);
    preg_match_all('/<li id="http:\/\/www.megavideo.com\/\?v=(.*?)">/',$html,$id);
   
    for ($i = 0; $i < sizeof($id[1]); $i++) {
      $part = (sizeof($id[1]) > 1) ? "/" . ($i+1) : "";
      $retMediaItems[] = array (
        'id' => 'umsp://plugins/cinetube?' . $id[1][$i],
        'dc:title' => html_entity_decode($title[1],0,"UTF-8") . " (" . html_entity_decode($quality[1][$z],0,"UTF-8") . " " . html_entity_decode($language[1][$z],0,"UTF-8") . ") (Megavideo #" . ($z+1) . $part . ")",
        'res' => "http://localhost/umsp/plugins/megavideo-proxy.php?id=" . $id[1][$i],
        'upnp:class' => 'object.item.videoitem',
        'protocolInfo' => '*:*:*:*'
      );
    }
  }
   
  for ($z = 0; $z < sizeof($megaup[1]); $z++) {
    $html = file_get_contents("http://www.cinetube.es" . $megaup[1][$z]);
    preg_match_all('/<a href="http:\/\/www.megaupload.com\/\?d=(.*?)" target=/',$html,$id);     
         
    $opts = array(
       'http' => array(
          'method' => "HEAD",
         'max_redirects' => '0',
         'header' => 'Cookie: user=' . $auth . "\r\n"
       )
    );
    $context = stream_context_create($opts);
       
    for ($i = 0; $i < sizeof($id[1]); $i++) {
      $getHeaders = @file_get_contents("http://www.megaupload.com/?d=" . $id[1][$i], false, $context);
     
      if (preg_match('/location: (.+)/',$http_response_header[3],$res)) {
        $part = (sizeof($id[1]) > 1) ? "/" . ($i+1) : "";
        $retMediaItems[] = array (
          'id' => 'umsp://plugins/cinetube?' . $id[1][$i],
          'dc:title' => html_entity_decode($title[1],0,"UTF-8") . " (" . html_entity_decode($quality[1][$z+sizeof($megavid[1])],0,"UTF-8") . " " . html_entity_decode($language[1][$z+sizeof($megavid[1])],0,"UTF-8") . ") (Megaupload #" . ($z+1) . $part . ")",
          'res' => $res[1],
          'upnp:class' => 'object.item.videoitem',
          'protocolInfo' => '*:*:*:*'
        );
      }
    }
  }   
  return $retMediaItems;
}

?>